| OpendTect 8.0

Loading...
Searching...
No Matches
Public Member Functions | Protected Member Functions | Static Protected Member Functions | Protected Attributes | List of all members
Smoother1D< T > Class Template Reference
Algo

Smoothes a 1d signal with an operator. More...

`#include <smoother1d.h>`

Inheritance diagram for Smoother1D< T >:
[legend]

## Public Member Functions
| Smoother1D ()
| Smoother1D (const Smoother1D &)
void | fillPar (IOPar &) const
int | getWindowLength () const
const char * | getWindowName () const
float | getWindowParam () const
bool | operator== (const Smoother1D< T > &) const
void | setInput (const T *, int sz)
void | setOutput (T *)
bool | setWindow (const char *nm, float param, int length)
bool | usePar (const IOPar &)
Public Member Functions inherited from ParallelTask
virtual | ~ParallelTask ()
void | doParallel (bool yn)
bool | execute () override
virtual bool | executeParallel (bool parallel)
od_int64 | nrDone () const override
| May be -1, i.e. class does not report nrdone.
od_int64 | totalNr () const override
Public Member Functions inherited from ReportingTask
| ReportingTask (const ReportingTask &)=delete
virtual | ~ReportingTask ()
void | getProgress (const ReportingTask &)
ReportingTask & | operator= (const ReportingTask &)=delete
void | setSimpleMeter (bool yn, int repperc)
int | simpleMeterStep () const
bool | useSimpleMeter () const
Public Member Functions inherited from Task
| Task (const Task &)=delete
virtual | ~Task ()
virtual void | controlWork (Control)
virtual void | enableWorkControl (bool=true)
| Must be called before execute()
virtual uiRetVal | errorWithDetails () const
virtual Control | getState () const
Task & | operator= (const Task &)=delete
virtual uiString | uiMessage () const
virtual uiString | uiNrDoneText () const
bool | workControlEnabled () const
Public Member Functions inherited from NamedCallBacker
| NamedCallBacker (const char *nm=nullptr)
| NamedCallBacker (const NamedCallBacker &)=delete
| ~NamedCallBacker ()
virtual Notifier< NamedCallBacker > & | objectToBeDeleted () const
NamedCallBacker & | operator= (const NamedCallBacker &)=delete
bool | operator== (const NamedCallBacker &oth) const
bool | operator== (const NamedObject &oth) const
Public Member Functions inherited from CallBacker
| CallBacker ()
| CallBacker (const CallBacker &)
virtual | ~CallBacker ()
bool | attachCB (const NotifierAccess &, const CallBack &, bool onlyifnew=false) const
bool | attachCB (const NotifierAccess *notif, const CallBack &cb, bool onlyifnew=false) const
void | detachAllNotifiers () const
| Call from the destructor of your inherited object.
void | detachCB (const NotifierAccess &, const CallBack &) const
void | detachCB (const NotifierAccess *notif, const CallBack &cb) const
virtual bool | isCapsule () const
bool | isNotifierAttached (const NotifierAccess *) const
| Only for debugging purposes, don't use.
CallBacker & | operator= (const CallBacker &)=delete
void | stopReceivingNotifications () const
virtual CallBacker * | trueCaller ()
Public Member Functions inherited from NamedObject
| NamedObject (const char *nm=nullptr)
| NamedObject (const NamedObject &oth)
virtual | ~NamedObject ()
virtual BufferString | getName () const
bool | getNameFromPar (const IOPar &)
const name_type & | name () const override
NamedObject & | operator= (const NamedObject &)
bool | operator== (const NamedObject &oth) const
virtual void | setName (const char *nm)
Public Member Functions inherited from ObjectWithName
virtual | ~ObjectWithName ()
bool | hasName (const char *nm) const
bool | hasName (const name_type &nm) const
void | putNameInPar (IOPar &) const

## Protected Member Functions
bool | doPrepare (int) override
bool | doWork (od_int64 start, od_int64 stop, int) override
od_int64 | nrIterations () const override
Protected Member Functions inherited from ParallelTask
| ParallelTask (const char *nm=0)
void | addToNrDone (od_int64 increment)
od_int64 | calculateThreadSize (od_int64 totalnr, int nrthreads, int thread) const
virtual int | maxNrThreads () const
virtual int | minThreadSize () const
void | quickAddToNrDone (od_int64 loopidx)
void | resetNrDone ()
virtual bool | stopAllOnFailure () const
Protected Member Functions inherited from ReportingTask
| ReportingTask (const char *nm=nullptr)
void | incrementProgress ()
ProgressMeter * | progressMeter () const
void | reportProgressFinished ()
void | reportProgressStarted ()
void | resetProgress ()
void | setProgressMeter (ProgressMeter *) override
| Must be called before execute()
void | updateProgressMeter (bool forced=false, od_int64 *totalnr=0)
void | updateReportedName ()
Protected Member Functions inherited from Task
| Task (const char *nm=nullptr)
virtual bool | shouldContinue ()
Protected Member Functions inherited from NamedCallBacker
void | sendDelNotif () const

## Static Protected Member Functions
static const char * | sKeyWinFunc ()
static const char * | sKeyWinLen ()
static const char * | sKeyWinParam ()

## Protected Attributes
int | firstdefined_
const T * | input_
int | lastdefined_
T * | output_
od_int64 | size_
TypeSet< T > | window_
BufferString | windowname_
float | windowparam_
Protected Attributes inherited from Task
Control | control_ = Task::Run
Threads::ConditionVar * | workcontrolcondvar_ = nullptr
Protected Attributes inherited from NamedCallBacker
Threads::Atomic< bool > | delalreadytriggered_
Notifier< NamedCallBacker > | delnotif_
Protected Attributes inherited from NamedObject
BufferString | name_

## Additional Inherited Members
Public Types inherited from Task
enum | Control { Run , Pause , Stop }
Public Types inherited from ObjectWithName
typedef OD::String | name_type
Static Public Member Functions inherited from ParallelTask
static uiString | sPosFinished ()
static uiString | sTrcFinished ()
Static Public Member Functions inherited from ReportingTask
static PtrMan< ProgressMeter > | getTextProgressMeter (od_ostream &, const IOPar *iop=nullptr)
static bool | needSimpleLogging (const IOPar &)
static const char * | sKeySimpleLogging ()
static const char * | sKeySimpleLoggingStep ()
Static Public Member Functions inherited from Task
static uiString | uiStdNrDoneText ()
Static Public Member Functions inherited from CallBacker
static void | createReceiverForCurrentThread ()
static void | removeReceiverForCurrentThread ()
Public Attributes inherited from ReportingTask
Notifier< ReportingTask > | progressUpdated

## Detailed Description

template<class T>
class Smoother1D< T >

Smoothes a 1d signal with an operator.

<>

## Constructor & Destructor Documentation

## ◆ Smoother1D() [1/2]

template<class T >

Smoother1D< T >::Smoother1D | ( |  | ) |
| inline

## ◆ Smoother1D() [2/2]

template<class T >

Smoother1D< T >::Smoother1D | ( | const Smoother1D< T > & | b | ) |
| inline

## Member Function Documentation

## ◆ doPrepare()

template<class T >

bool Smoother1D< T >::doPrepare | ( | int | nrthreads | ) |
| inline override protected virtual

Called once, before any doWork is called.

Reimplemented from ParallelTask.

## ◆ doWork()

template<class T >

bool Smoother1D< T >::doWork | ( | od_int64 | start,
|  | od_int64 | stop,
|  | int | threadidx )
| inline override protected virtual

The functions that does the job. The function will be called with all intervals from 0 to ParallelTask::nrIterations()-1. The function must be designed to be able to run in parallel.

Parameters

  start | first index
  stop | last index
  threadidx | gives an identifier (between 0 and nr of threads -1) that is unique to each call to doWork.

Implements ParallelTask.

## ◆ fillPar()

template<class T >

void Smoother1D< T >::fillPar | ( | IOPar & | par | ) | const
| inline

## ◆ getWindowLength()

template<class T >

int Smoother1D< T >::getWindowLength | ( |  | ) | const
| inline

## ◆ getWindowName()

template<class T >

const char * Smoother1D< T >::getWindowName | ( |  | ) | const
| inline

## ◆ getWindowParam()

template<class T >

float Smoother1D< T >::getWindowParam | ( |  | ) | const
| inline

## ◆ nrIterations()

template<class T >

od_int64 Smoother1D< T >::nrIterations | ( |  | ) | const
| inline override protected virtual

Returns
  the number of times the process should be run.

Implements ParallelTask.

## ◆ operator==()

template<class T >

bool Smoother1D< T >::operator== | ( | const Smoother1D< T > & | b | ) | const
| inline

## ◆ setInput()

template<class T >

void Smoother1D< T >::setInput | ( | const T * | ni,
|  | int | sz )
| inline

## ◆ setOutput()

template<class T >

void Smoother1D< T >::setOutput | ( | T * | ni | ) |
| inline

## ◆ setWindow()

template<class T >

bool Smoother1D< T >::setWindow | ( | const char * | nm,
|  | float | param,
|  | int | length )
| inline

Must be at least the size of input.

## ◆ sKeyWinFunc()

template<class T >

static const char * Smoother1D< T >::sKeyWinFunc | ( |  | ) |
| inline static protected

## ◆ sKeyWinLen()

template<class T >

static const char * Smoother1D< T >::sKeyWinLen | ( |  | ) |
| inline static protected

## ◆ sKeyWinParam()

template<class T >

static const char * Smoother1D< T >::sKeyWinParam | ( |  | ) |
| inline static protected

## ◆ usePar()

template<class T >

bool Smoother1D< T >::usePar | ( | const IOPar & | par | ) |
| inline

## Member Data Documentation

## ◆ firstdefined_

template<class T >

int Smoother1D< T >::firstdefined_
| protected

## ◆ input_

template<class T >

const T* Smoother1D< T >::input_
| protected

## ◆ lastdefined_

template<class T >

int Smoother1D< T >::lastdefined_
| protected

## ◆ output_

template<class T >

T* Smoother1D< T >::output_
| protected

## ◆ size_

template<class T >

od_int64 Smoother1D< T >::size_
| protected

## ◆ window_

template<class T >

TypeSet<T> Smoother1D< T >::window_
| protected

## ◆ windowname_

template<class T >

BufferString Smoother1D< T >::windowname_
| protected

## ◆ windowparam_

template<class T >

float Smoother1D< T >::windowparam_
| protected

Generated at
for the OpendTect seismic interpretation project. Copyright (C): dGB Beheer B.V. 1995-2025